"use strict";

var _mobx = require("mobx");

var _task = _interopRequireDefault(require("../task"));

var _promiseDefer = _interopRequireDefault(require("promise-defer"));

var _memoize = _interopRequireDefault(require("lodash/memoize"));

var _autobindDecorator = _interopRequireDefault(require("autobind-decorator"));

var _sinon = require("sinon");

var _smid = require("smid");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and set to use loose mode. ' + 'To use proposal-class-properties in spec mode with decorators, wait for ' + 'the next major version of decorators in stage 2.'); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

test('goes from pending -> resolved',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var d, base, fn, p, result;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          d = (0, _promiseDefer["default"])();
          base = (0, _sinon.spy)(function () {
            return d.promise;
          });
          fn = (0, _task["default"])(base);
          expect(fn.state === 'pending').toBe(true);
          expect(fn.pending === true).toBe(true);
          p = fn(1, 2, 3);
          expect(fn.state === 'pending').toBe(true);
          expect(fn.pending === true).toBe(true);
          d.resolve(1337);
          _context.next = 11;
          return p;

        case 11:
          result = _context.sent;
          expect(result).toBe(1337);
          expect(fn.pending).toBe(false);
          expect(fn.rejected).toBe(false);
          expect(fn.resolved).toBe(true);
          expect(fn.result).toBe(1337);
          expect(fn.state).toBe('resolved');

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
test('goes from pending -> rejected on error',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var d, base, fn, p, err, result;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          d = (0, _promiseDefer["default"])();
          base = (0, _sinon.spy)(function () {
            return d.promise;
          });
          fn = (0, _task["default"])(base);
          expect(fn.state === 'pending').toBe(true);
          expect(fn.pending === true).toBe(true);
          p = fn(1, 2, 3);
          expect(fn.state === 'pending').toBe(true);
          expect(fn.pending === true).toBe(true);
          err = new Error('hah');
          d.reject(err);
          _context2.next = 12;
          return (0, _smid["throws"])(function () {
            return p;
          });

        case 12:
          result = _context2.sent;
          expect(result).toBe(err);
          expect(fn.pending).toBe(false);
          expect(fn.rejected).toBe(true);
          expect(fn.resolved).toBe(false);
          expect(fn.result).toBe(undefined);
          expect(fn.error).toBe(err);
          expect(fn.state).toBe('rejected');

        case 20:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
})));
test('goes from resolved -> pending -> resolved when state is set',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee3() {
  var d, fn, p;
  return regeneratorRuntime.wrap(function _callee3$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          d = (0, _promiseDefer["default"])();
          fn = (0, _task["default"])(function () {
            return d.promise;
          }, {
            state: 'resolved'
          });
          expect(fn.resolved).toBe(true);
          p = fn();
          expect(fn.pending).toBe(true);
          d.resolve(1337);
          _context3.next = 8;
          return p;

        case 8:
          expect(fn.resolved).toBe(true);

        case 9:
        case "end":
          return _context3.stop();
      }
    }
  }, _callee3);
})));
test('state is reactive', function () {
  var fn = (0, _task["default"])(function () {
    return 1337;
  });
  var isPending = (0, _sinon.spy)();
  var isResolved = (0, _sinon.spy)();
  var isRejected = (0, _sinon.spy)();
  (0, _mobx.reaction)(function () {
    return fn.pending;
  }, isPending);
  (0, _mobx.reaction)(function () {
    return fn.resolved;
  }, isResolved);
  (0, _mobx.reaction)(function () {
    return fn.rejected;
  }, isRejected);
  fn.setState({
    state: 'resolved'
  });
  fn.setState({
    state: 'rejected'
  });
  fn.setState({
    state: 'pending'
  }); // these goes from false to true, and from true to false

  expect(isPending.callCount).toBe(2);
  expect(isResolved.callCount).toBe(2);
  expect(isRejected.callCount).toBe(2);
});
test('setState lets me modify the internal state', function () {
  var fn = (0, _task["default"])(function () {
    return 1337;
  });
  expect(fn.pending).toBe(true);
  fn.setState({
    state: 'resolved',
    result: 123
  });
  expect(fn.result).toBe(123);
  expect(fn.resolved).toBe(true);
});
test('there are shortcuts to check the state.', function () {
  var fn = (0, _task["default"])(function () {
    return 1337;
  });
  expect(fn.state).toBe('pending');
  expect(fn.pending).toBe(true);
  expect(fn.resolved).toBe(false);
  expect(fn.rejected).toBe(false);
  fn.setState({
    state: 'resolved',
    result: 123
  });
  expect(fn.state).toBe('resolved');
  expect(fn.pending).toBe(false);
  expect(fn.resolved).toBe(true);
  expect(fn.rejected).toBe(false);
  fn.setState({
    state: 'rejected'
  });
  expect(fn.state).toBe('rejected');
  expect(fn.pending).toBe(false);
  expect(fn.resolved).toBe(false);
  expect(fn.rejected).toBe(true);
});
test('task.resolved shorthand sets state: resolved', function () {
  var fn = _task["default"].resolved(function () {
    return 1337;
  });

  expect(fn.resolved).toBe(true);
});
test('swallow: true does not throw exceptions',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee4() {
  var err, fn, result;
  return regeneratorRuntime.wrap(function _callee4$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          err = new Error('haha shiit');
          fn = (0, _task["default"])(function () {
            return Promise.reject(err);
          }, {
            swallow: true
          });
          _context4.next = 4;
          return fn(123);

        case 4:
          result = _context4.sent;
          expect(result).toBe(undefined);
          expect(fn.result).toBe(undefined);
          expect(fn.error).toBe(err);

        case 8:
        case "end":
          return _context4.stop();
      }
    }
  }, _callee4);
})));
test('regular decorator',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee5() {
  var _class;

  var d, Test, test, p, result;
  return regeneratorRuntime.wrap(function _callee5$(_context5) {
    while (1) {
      switch (_context5.prev = _context5.next) {
        case 0:
          d = (0, _promiseDefer["default"])();
          Test = (_class =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);
            }

            _createClass(Test, [{
              key: "fn",
              value: function fn(arg) {
                return d.promise.then(function () {
                  return arg;
                });
              }
            }]);

            return Test;
          }(), (_applyDecoratedDescriptor(_class.prototype, "fn", [_task["default"]], Object.getOwnPropertyDescriptor(_class.prototype, "fn"), _class.prototype)), _class);
          test = new Test();
          expect(test.fn.pending).toBe(true);
          p = test.fn(123);
          expect(test.fn.pending).toBe(true);
          d.resolve(1337);
          _context5.next = 9;
          return p;

        case 9:
          result = _context5.sent;
          expect(result).toBe(123);
          expect(test.fn.resolved).toBe(true);
          expect(test.fn.result).toBe(123);

        case 13:
        case "end":
          return _context5.stop();
      }
    }
  }, _callee5);
})));
test('decorator factory', function () {
  var _dec, _class2;

  var Test = (_dec = (0, _task["default"])({
    state: 'resolved',
    result: 1337
  }), (_class2 =
  /*#__PURE__*/
  function () {
    function Test() {
      _classCallCheck(this, Test);
    }

    _createClass(Test, [{
      key: "fn",
      value: function fn(arg) {}
    }]);

    return Test;
  }(), (_applyDecoratedDescriptor(_class2.prototype, "fn", [_dec], Object.getOwnPropertyDescriptor(_class2.prototype, "fn"), _class2.prototype)), _class2));
  var test = new Test();
  expect(test.fn.resolved).toBe(true);
  expect(test.fn.result).toBe(1337);
});
test('preconfigured decorator', function () {
  var _dec2, _dec3, _class3;

  var error = new Error('hah');
  var Test = (_dec2 = _task["default"].resolved, _dec3 = _task["default"].rejected({
    error: error
  }), (_class3 =
  /*#__PURE__*/
  function () {
    function Test() {
      _classCallCheck(this, Test);
    }

    _createClass(Test, [{
      key: "fnResolved",
      value: function fnResolved() {}
    }, {
      key: "fnRejected",
      value: function fnRejected() {}
    }]);

    return Test;
  }(), (_applyDecoratedDescriptor(_class3.prototype, "fnResolved", [_dec2], Object.getOwnPropertyDescriptor(_class3.prototype, "fnResolved"), _class3.prototype), _applyDecoratedDescriptor(_class3.prototype, "fnRejected", [_dec3], Object.getOwnPropertyDescriptor(_class3.prototype, "fnRejected"), _class3.prototype)), _class3));
  var test = new Test();
  expect(test.fnResolved.resolved).toBe(true);
  expect(test.fnRejected.rejected).toBe(true);
  expect(test.fnRejected.error).toBe(error);
});
test('bind returns a task function',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee6() {
  var fn, that, bound, boundResult;
  return regeneratorRuntime.wrap(function _callee6$(_context6) {
    while (1) {
      switch (_context6.prev = _context6.next) {
        case 0:
          fn = (0, _task["default"])(function (arg1) {
            return [this, arg1];
          });
          that = {};
          bound = fn.bind(that, 1);
          _context6.next = 5;
          return bound(1337);

        case 5:
          boundResult = _context6.sent;
          expect(boundResult[0]).toBe(that);
          expect(boundResult[1]).toBe(1);

        case 8:
        case "end":
          return _context6.stop();
      }
    }
  }, _callee6);
})));
test('wrap returns a task function',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee7() {
  var fn;
  return regeneratorRuntime.wrap(function _callee7$(_context7) {
    while (1) {
      switch (_context7.prev = _context7.next) {
        case 0:
          fn = (0, _task["default"])(function () {
            return 42;
          }).wrap(function (f) {
            var inner = function inner() {
              inner.callCount += 1;
              return f();
            };

            inner.callCount = 0;
            return inner;
          });
          _context7.t0 = expect;
          _context7.next = 4;
          return fn();

        case 4:
          _context7.t1 = _context7.sent;
          (0, _context7.t0)(_context7.t1).toBe(42);
          expect(fn.callCount).toBe(1);
          expect(fn.resolved).toBe(true);

        case 8:
        case "end":
          return _context7.stop();
      }
    }
  }, _callee7);
})));
test('can be memoized',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee8() {
  var i, fn;
  return regeneratorRuntime.wrap(function _callee8$(_context8) {
    while (1) {
      switch (_context8.prev = _context8.next) {
        case 0:
          i = 1;
          fn = (0, _task["default"])(function () {
            return i++;
          }).wrap(_memoize["default"]);
          _context8.t0 = expect;
          _context8.next = 5;
          return fn();

        case 5:
          _context8.t1 = _context8.sent;
          (0, _context8.t0)(_context8.t1).toBe(1);
          _context8.t2 = expect;
          _context8.next = 10;
          return fn();

        case 10:
          _context8.t3 = _context8.sent;
          (0, _context8.t2)(_context8.t3).toBe(1);
          expect(fn.resolved).toBe(true);

        case 13:
        case "end":
          return _context8.stop();
      }
    }
  }, _callee8);
})));
test('can decorate an already decorated method',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee9() {
  var _dec4, _class4;

  var Test, test, method;
  return regeneratorRuntime.wrap(function _callee9$(_context9) {
    while (1) {
      switch (_context9.prev = _context9.next) {
        case 0:
          /**
           * For this to work the task decorator has
           * to be the last decorator to run (declared first)
           */
          Test = (_dec4 = _mobx.action.bound, (_class4 =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);
            }

            _createClass(Test, [{
              key: "method",
              value: function method() {
                return this;
              }
            }]);

            return Test;
          }(), (_applyDecoratedDescriptor(_class4.prototype, "method", [_task["default"], _dec4], Object.getOwnPropertyDescriptor(_class4.prototype, "method"), _class4.prototype)), _class4));
          test = new Test();
          expect(test.method.pending).toBe(true);
          method = test.method;
          _context9.t0 = expect;
          _context9.next = 7;
          return method();

        case 7:
          _context9.t1 = _context9.sent;
          _context9.t2 = test;
          (0, _context9.t0)(_context9.t1).toBe(_context9.t2);
          _context9.t3 = expect;
          _context9.next = 13;
          return method();

        case 13:
          _context9.t4 = _context9.sent;
          _context9.t5 = test;
          (0, _context9.t3)(_context9.t4).toBe(_context9.t5);

        case 16:
        case "end":
          return _context9.stop();
      }
    }
  }, _callee9);
})));
test('can be tacked onto an observable',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee11() {
  var store;
  return regeneratorRuntime.wrap(function _callee11$(_context11) {
    while (1) {
      switch (_context11.prev = _context11.next) {
        case 0:
          store = (0, _mobx.observable)({
            todos: [],
            fetchTodos: (0, _task["default"])(
            /*#__PURE__*/
            _asyncToGenerator(
            /*#__PURE__*/
            regeneratorRuntime.mark(function _callee10() {
              return regeneratorRuntime.wrap(function _callee10$(_context10) {
                while (1) {
                  switch (_context10.prev = _context10.next) {
                    case 0:
                      return _context10.abrupt("return", [{
                        text: 'install mobx-task'
                      }]);

                    case 1:
                    case "end":
                      return _context10.stop();
                  }
                }
              }, _callee10);
            })))
          });
          expect(store.fetchTodos.pending).toBe(true);
          _context11.next = 4;
          return store.fetchTodos();

        case 4:
          expect(store.fetchTodos.resolved).toBe(true);

        case 5:
        case "end":
          return _context11.stop();
      }
    }
  }, _callee11);
})));
test('match returns the case for the current state', function () {
  var fn = (0, _task["default"])(function () {
    return undefined;
  });

  var run = function run() {
    return fn.match({
      pending: function pending() {
        return 1;
      },
      resolved: function resolved(value) {
        return value;
      },
      rejected: function rejected(err) {
        return err.message;
      }
    });
  };

  expect(run()).toBe(1);
  fn.setState({
    state: 'resolved',
    result: 42
  });
  expect(run()).toBe(42);
  fn.setState({
    state: 'rejected',
    error: new Error('hah')
  });
  expect(run()).toBe('hah');
});
test('match returns undefined if there is no case', function () {
  var fn = (0, _task["default"])(function () {
    return undefined;
  });

  var run = function run() {
    return fn.match({
      resolved: function resolved(value) {
        return value;
      },
      rejected: function rejected(err) {
        return err.message;
      }
    });
  };

  expect(run()).toBe(undefined);
  fn.setState({
    state: 'resolved',
    result: 42
  });
  expect(run()).toBe(42);
  fn.setState({
    state: 'rejected',
    error: new Error('hah')
  });
  expect(run()).toBe('hah');
});
test('match passes arguments to pending', function () {
  var fn = (0, _task["default"])(function () {
    return undefined;
  });
  var calledWith = null;
  fn(1, 2);
  fn.match({
    pending: function pending(arg1, arg2) {
      calledWith = [arg1, arg2];
    }
  });
  expect(calledWith).toEqual([1, 2]);
});
test('calling the function multiple times will only trigger setState:resolved once',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee12() {
  var fn, d1, d2, p1, p2, r1, r2;
  return regeneratorRuntime.wrap(function _callee12$(_context12) {
    while (1) {
      switch (_context12.prev = _context12.next) {
        case 0:
          fn = (0, _task["default"])(function (d) {
            return d.promise;
          });
          d1 = (0, _promiseDefer["default"])();
          d2 = (0, _promiseDefer["default"])();
          p1 = fn(d1);
          p2 = fn(d2);
          _context12.next = 7;
          return new Promise(function (resolve) {
            return setTimeout(resolve, 20);
          });

        case 7:
          d1.resolve(1);
          _context12.next = 10;
          return p1;

        case 10:
          r1 = _context12.sent;
          expect(fn.pending).toBe(true);
          d2.resolve(2);
          _context12.next = 15;
          return p2;

        case 15:
          r2 = _context12.sent;
          expect(fn.resolved).toBe(true);
          expect(r1).toBe(1);
          expect(r2).toBe(2);

        case 19:
        case "end":
          return _context12.stop();
      }
    }
  }, _callee12);
})));
test('calling the function multiple times will not trigger setState:rejected if not the last call',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee13() {
  var fn, d1, d2, p1, p2, r1, r2;
  return regeneratorRuntime.wrap(function _callee13$(_context13) {
    while (1) {
      switch (_context13.prev = _context13.next) {
        case 0:
          fn = (0, _task["default"])(function (d) {
            return d.promise;
          });
          d1 = (0, _promiseDefer["default"])();
          d2 = (0, _promiseDefer["default"])();
          p1 = fn(d1);
          p2 = fn(d2);
          _context13.next = 7;
          return new Promise(function (resolve) {
            return setTimeout(resolve, 20);
          });

        case 7:
          d1.reject(new Error('Oh shit'));
          _context13.next = 10;
          return (0, _smid["throws"])(function () {
            return p1;
          });

        case 10:
          r1 = _context13.sent;
          expect(fn.pending).toBe(true);
          d2.resolve(2);
          _context13.next = 15;
          return p2;

        case 15:
          r2 = _context13.sent;
          expect(fn.resolved).toBe(true);
          expect(r1.message).toBe('Oh shit');
          expect(r2).toBe(2);

        case 19:
        case "end":
          return _context13.stop();
      }
    }
  }, _callee13);
})));
test('catches sync errors',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee14() {
  var fn;
  return regeneratorRuntime.wrap(function _callee14$(_context14) {
    while (1) {
      switch (_context14.prev = _context14.next) {
        case 0:
          fn = (0, _task["default"])(function () {
            throw new Error('hah');
          });
          _context14.next = 3;
          return (0, _smid["throws"])(function () {
            return fn();
          });

        case 3:
          expect(fn.rejected).toBe(true);
          expect(fn.error.message).toBe('hah');

        case 5:
        case "end":
          return _context14.stop();
      }
    }
  }, _callee14);
})));
test('reset() resets the state to resolved with result',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee15() {
  var fn, result, fromReset;
  return regeneratorRuntime.wrap(function _callee15$(_context15) {
    while (1) {
      switch (_context15.prev = _context15.next) {
        case 0:
          fn = (0, _task["default"])(function () {
            return 1337;
          }, {
            state: 'resolved',
            result: 42
          });
          expect(fn.result).toBe(42);
          _context15.next = 4;
          return fn();

        case 4:
          result = _context15.sent;
          expect(result).toBe(1337);
          expect(fn.state).toBe('resolved');
          fromReset = fn.reset();
          expect(fromReset).toBe(fn);
          expect(fn.result).toBe(42);

        case 10:
        case "end":
          return _context15.stop();
      }
    }
  }, _callee15);
})));
test('reset() resets the state to pending',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee16() {
  var fn, result;
  return regeneratorRuntime.wrap(function _callee16$(_context16) {
    while (1) {
      switch (_context16.prev = _context16.next) {
        case 0:
          fn = (0, _task["default"])(function () {
            return 1337;
          });
          expect(fn.result).toBe(undefined);
          _context16.next = 4;
          return fn();

        case 4:
          result = _context16.sent;
          expect(result).toBe(1337);
          expect(fn.state).toBe('resolved');
          fn.reset();
          expect(fn.result).toBe(undefined);
          expect(fn.state).toBe('pending');

        case 10:
        case "end":
          return _context16.stop();
      }
    }
  }, _callee16);
})));
test('autobind works',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee17() {
  var _class5, _class6;

  var Test, sub, fn, result;
  return regeneratorRuntime.wrap(function _callee17$(_context17) {
    while (1) {
      switch (_context17.prev = _context17.next) {
        case 0:
          Test = (0, _autobindDecorator["default"])(_class5 = (_class6 =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);

              this.value = 42;
            }

            _createClass(Test, [{
              key: "func",
              value: function func() {
                return this.value;
              }
            }]);

            return Test;
          }(), (_applyDecoratedDescriptor(_class6.prototype, "func", [_task["default"], _autobindDecorator["default"]], Object.getOwnPropertyDescriptor(_class6.prototype, "func"), _class6.prototype)), _class6)) || _class5;
          sub = new Test();
          fn = sub.func;
          _context17.next = 5;
          return fn();

        case 5:
          result = _context17.sent;
          expect(result).toBe(42);
          expect(fn.state).toBe('resolved');
          expect(sub.func.state).toBe('resolved');

        case 9:
        case "end":
          return _context17.stop();
      }
    }
  }, _callee17);
})));
test('can reassign decorated method',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee18() {
  var _class7;

  var Test, sub;
  return regeneratorRuntime.wrap(function _callee18$(_context18) {
    while (1) {
      switch (_context18.prev = _context18.next) {
        case 0:
          Test = (_class7 =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);
            }

            _createClass(Test, [{
              key: "method",
              value: function method() {}
            }]);

            return Test;
          }(), (_applyDecoratedDescriptor(_class7.prototype, "method", [_task["default"]], Object.getOwnPropertyDescriptor(_class7.prototype, "method"), _class7.prototype)), _class7);
          sub = new Test();
          sub.method = 123;
          expect(sub.method).toBe(123);

        case 4:
        case "end":
          return _context18.stop();
      }
    }
  }, _callee18);
})));
test('decorator value is cached',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee19() {
  var _class8;

  var Test, sub;
  return regeneratorRuntime.wrap(function _callee19$(_context19) {
    while (1) {
      switch (_context19.prev = _context19.next) {
        case 0:
          Test = (_class8 =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);
            }

            _createClass(Test, [{
              key: "method",
              value: function method() {
                return 42;
              }
            }]);

            return Test;
          }(), (_applyDecoratedDescriptor(_class8.prototype, "method", [_task["default"]], Object.getOwnPropertyDescriptor(_class8.prototype, "method"), _class8.prototype)), _class8);
          sub = new Test();
          _context19.t0 = expect;
          _context19.next = 5;
          return sub.method();

        case 5:
          _context19.t1 = _context19.sent;
          (0, _context19.t0)(_context19.t1).toBe(42);
          _context19.t2 = expect;
          _context19.next = 10;
          return sub.method();

        case 10:
          _context19.t3 = _context19.sent;
          (0, _context19.t2)(_context19.t3).toBe(42);

        case 12:
        case "end":
          return _context19.stop();
      }
    }
  }, _callee19);
})));
test('decorator supports fields with functions',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee20() {
  var _class9, _descriptor, _temp;

  var Test, sub;
  return regeneratorRuntime.wrap(function _callee20$(_context20) {
    while (1) {
      switch (_context20.prev = _context20.next) {
        case 0:
          Test = (_class9 = (_temp = function Test() {
            _classCallCheck(this, Test);

            _initializerDefineProperty(this, "method", _descriptor, this);
          }, _temp), (_descriptor = _applyDecoratedDescriptor(_class9.prototype, "method", [_task["default"]], {
            configurable: true,
            enumerable: true,
            writable: true,
            initializer: function initializer() {
              return function () {
                return 42;
              };
            }
          })), _class9);
          sub = new Test();
          _context20.t0 = expect;
          _context20.next = 5;
          return sub.method();

        case 5:
          _context20.t1 = _context20.sent;
          (0, _context20.t0)(_context20.t1).toBe(42);

        case 7:
        case "end":
          return _context20.stop();
      }
    }
  }, _callee20);
})));
test('decorator supports fields with arrow functions',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee21() {
  var _class11, _descriptor2, _temp2;

  var Test, sub;
  return regeneratorRuntime.wrap(function _callee21$(_context21) {
    while (1) {
      switch (_context21.prev = _context21.next) {
        case 0:
          Test = (_class11 = (_temp2 =
          /*#__PURE__*/
          function () {
            function Test() {
              _classCallCheck(this, Test);

              _initializerDefineProperty(this, "method", _descriptor2, this);
            }

            _createClass(Test, [{
              key: "getValue",
              value: function getValue() {
                return 42;
              }
            }]);

            return Test;
          }(), _temp2), (_descriptor2 = _applyDecoratedDescriptor(_class11.prototype, "method", [_task["default"]], {
            configurable: true,
            enumerable: true,
            writable: true,
            initializer: function initializer() {
              var _this = this;

              return function () {
                return _this.getValue();
              };
            }
          })), _class11);
          sub = new Test();
          _context21.t0 = expect;
          _context21.next = 5;
          return sub.method();

        case 5:
          _context21.t1 = _context21.sent;
          (0, _context21.t0)(_context21.t1).toBe(42);

        case 7:
        case "end":
          return _context21.stop();
      }
    }
  }, _callee21);
})));
//# sourceMappingURL=task.test.js.map