"use strict";

var _utils = require("../utils");

var _smid = require("smid");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

test('promiseTry catches all errors and rejects promise',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var err;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _smid["throws"])(function () {
            return (0, _utils.promiseTry)(function () {
              throw new Error('hah');
            });
          });

        case 2:
          err = _context.sent;
          expect(err.message).toBe('hah');

        case 4:
        case "end":
          return _context.stop();
      }
    }
  }, _callee);
})));
test('promiseTry returns a promise that resolves',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee2() {
  var result;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _utils.promiseTry)(function () {
            return 42;
          });

        case 2:
          result = _context2.sent;
          expect(result).toBe(42);

        case 4:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
})));
test('proxyGetters defines getters for values on the given object', function () {
  var target = function target() {
    return 42;
  };

  var values = {
    val1: 1,
    val2: 2
  };
  (0, _utils.proxyGetters)(target, values, ['val1', 'val2']);
  expect(target.val1).toBe(1);
  expect(target.val2).toBe(2);
  expect(target.val3).toBe(undefined);
  values.val1 = 1000;
  expect(target.val1).toBe(1000);
});
//# sourceMappingURL=utils.test.js.map